########## S script: sec.4.1.s ##########

# S-PLUS code listed in Section 4.1 of
# the paper "Smoothing and Mixed Model Software"
# by Ngo & Wand.

# Load in default.knots() function.
	
source("default.knots.sf")	

onions <- read.table("onions.dat",header=T)
dens <- onions$density
log.yield <- log(onions$yield)
location <- onions$location

#Set up design matrices for a binary offset model.

X <- cbind(rep(1,length(dens)),dens,location)
knots <- default.knots(dens)
Z <- outer(dens,knots,"-")
Z <- Z*(Z>0)

#Obtain the fit using mixed model function 

fit <- lme(log.yield~-1+X,random=pdIdent(~-1+Z))
beta.hat <- fit$coef$fixed
u.hat <- unlist(fit$coef$random)

#Extract the estimated standard deviation components

sig.eps.hat <- fit$sigma
sig.u.hat   <- sig.eps.hat*exp(unlist(fit$modelStruct))

print(summary(fit)$tTable)

########## End of sec.4.1.s ##########
