/********** SAS code: sec.4.2.sas **************

 SAS code listed in Section 4.2 of
 the paper "Smoothing and Mixed Model Software"
 by Ngo & Wand
 
 ***********************************************/

libname paper '~/test';
data paper.onions;
  infile '~/test/onions.dat' missover;
  input density yield location; 
  logyield=log(yield);
  if density = . then delete;
run;  
%include "default_knots.macro"; 
%default_knots(librefknots=paper,data=paper.onions,knotdata=onionsknots,varknots=density);
data dataw;
  set paper.onions (keep=logyield density location);
  m=1;
run;
data kt1;
  set paper.onionsknots nobs=nk;
  call symput('nkt',nk);
run;
proc transpose data=paper.onionsknots prefix=knots out=knotst;
  var knots;
run;
data paper.knotst;
  set knotst;
  m=1;
run;
data dataw;
  merge dataw paper.knotst;
  by m;
  %let nk=&nkt;
  array Z (&nk) Z1-Z&nk;
  array knots (&nk) knots1-knots&nk;
  do k=1 to &nk;
    Z(k)=density-knots(k);
    if Z(k) < 0 then Z(k)=0;
  end;
  drop knots1-knots&nk _name_;
run;
ods output CovParms=paper.varcomp;
proc mixed;
  model logyield = location density / solution outp=paper.yhat;
  random  Z1-Z&nk / type=toep(1) s;
run;
  
************* End of sec.4.2.sas **************  
