########## S script: sec.8.1.S ##########

# S-PLUS code listed in Section 8.1 of
# the paper "Smoothing and Mixed Model Software"
# by Ngo & Wand.

# Load in default.knots() function.
	
source("default.knots.sf")

z <- ethanol$E
x <- ethanol$C
y <- ethanol$NOx
X <- cbind(rep(1,length(y)),z,x,x*z)
knots <- default.knots(z)
K <- length(knots)
Z <- outer(z,knots,"-")
Z <- Z*(Z>0)

Z <- cbind(Z,x*Z)
re.block.inds <- list(1:K,(K+1):(2*K))
       
Z.block  <-  list()
for (i in 1:length(re.block.inds))
   Z.block[[i]] <- as.formula(paste("~Z[,c(",paste(
             re.block.inds[[i]],collapse=","),")]-1"))
fit <- lme(y~-1+X,random=pdBlocked(Z.block,
           pdClass="pdIdent"))
           
                  
# The estimated fixed and random coefficients and fitted values are:

beta.hat <- fit$coef$fixed
u.hat <- unlist(fit$coef$random)
sig.eps.hat <- fit$sigma
sig.u.hat   <- sig.eps.hat*exp(unlist(fit$modelStruct))


########## End of sec.8.1.s ##########